#include <windows.h>
#include <XInput.h>
#include <MMSystem.h>
#include <tchar.h>

#pragma comment(lib, "winmm.lib")

#define BUTTON_MAX	12


// L[蓖č\ C#Ɠl
typedef struct
{
	int Left;
	int Up;
	int Right;
	int Down;
	int Buttons[BUTTON_MAX];
	int DisableMouse;
}ASSIGINED_KEY;

// L[ꂽǂ̃tO\
typedef struct
{
	BOOL Left;
	BOOL Up;
	BOOL Right;
	BOOL Down;
	BOOL Buttons[BUTTON_MAX];
}KEY_PRESSED;


ASSIGINED_KEY g_AssignedKey;
KEY_PRESSED g_KeyPressed;
WNDPROC g_WndProc;				// GameEBhẼnh
BOOL g_isActive = true;			// GameEBhEANeBuǂ

// WCpbh̏Ԃ擾Ċ蓖ĂꂽL[͂ɔf
void GetJoyPadState()
{
	JOYINFOEX joy;
	joy.dwSize = sizeof(JOYINFOEX);
	joy.dwFlags = JOY_RETURNALL;

	// WCpbh̃{^Ԃ擾
	joyGetPosEx(JOYSTICKID1, &joy);

	// XeBbNʒu 0`0xFFFF Œl̂ŁA-0x7FFF`0x7FFF ɕς
	int x = joy.dwXpos - 0x7FFF;
	int y = joy.dwYpos - 0x7FFF;

	// XeBbNEɌXĂH@臒l͂Ƃ肠1000
	if (x >= 1000)
	{
		// ܂EL[ĂȂH
		if (!g_KeyPressed.Right)
		{
			// uEL[vCxgWindowsɓ`B
			keybd_event(g_AssignedKey.Right, MapVirtualKey(g_AssignedKey.Right, 0), 0, 0);
			// EL[tO𗧂Ă
			g_KeyPressed.Right = true;
		}

	}
	else
	{
		// ɉEL[ĂH
		if (g_KeyPressed.Right)
		{
			// uEL[𗣂vCxgWindowsɓ`
			keybd_event(g_AssignedKey.Right, MapVirtualKey(g_AssignedKey.Right, 0), KEYEVENTF_KEYUP, 0);
			// EL[tONA
			g_KeyPressed.Right = false;
		}
	}


	// ȉAWCpbh̊e{^Ɗ蓖ăL[œl̏s

	// 
	if (x < -1000)
	{
		if (!g_KeyPressed.Left)
		{
			keybd_event(g_AssignedKey.Left, MapVirtualKey(g_AssignedKey.Left, 0), 0, 0);
			g_KeyPressed.Left = true;
		}

	}
	else
	{
		if (g_KeyPressed.Left)
		{
			keybd_event(g_AssignedKey.Left, MapVirtualKey(g_AssignedKey.Left, 0), KEYEVENTF_KEYUP, 0);
			g_KeyPressed.Left = false;
		}
	}


	// 
	if (y < -1000)
	{
		if (!g_KeyPressed.Up)
		{
			keybd_event(g_AssignedKey.Up, MapVirtualKey(g_AssignedKey.Up, 0), 0, 0);
			g_KeyPressed.Up = true;
		}
	}
	else
	{
		if (g_KeyPressed.Up)
		{
			keybd_event(g_AssignedKey.Up, MapVirtualKey(g_AssignedKey.Up, 0), KEYEVENTF_KEYUP, 0);
			g_KeyPressed.Up = false;
		}
	}

	// 
	if (y >= 1000)
	{
		if (!g_KeyPressed.Down)
		{
			keybd_event(g_AssignedKey.Down, MapVirtualKey(g_AssignedKey.Down, 0), 0, 0);
			g_KeyPressed.Down = true;
		}
	}
	else
	{
		if (g_KeyPressed.Down)
		{
			keybd_event(g_AssignedKey.Down, MapVirtualKey(g_AssignedKey.Down, 0), KEYEVENTF_KEYUP, 0);
			g_KeyPressed.Down = false;
		}
	}

	// {^
	for (int i = 0; i < BUTTON_MAX; i++)
	{
		int keyCode = g_AssignedKey.Buttons[i];

		if (keyCode != 0)
		{
			if (joy.dwButtons & (1 << i))
			{
				if (!g_KeyPressed.Buttons[i])
				{
					keybd_event(keyCode, MapVirtualKey(keyCode, 0), 0, 0);
					g_KeyPressed.Buttons[i] = true;
				}
			}
			else
			{
				if (g_KeyPressed.Buttons[i])
				{
					keybd_event(keyCode, MapVirtualKey(keyCode, 0), KEYEVENTF_KEYUP, 0);
					g_KeyPressed.Buttons[i] = false;
				}
			}
		}

	}
}

// ȉAXInput̃tbN֐
DWORD WINAPI XInputGetDSoundAudioDeviceGuids(
  DWORD dwUserIndex,
  GUID* pDSoundRenderGuid,
  GUID* pDSoundCaptureGuid
)
{
	return ERROR_SUCCESS;
}

DWORD WINAPI XInputGetCapabilities(
  DWORD dwUserIndex,
  DWORD dwFlags,
  XINPUT_CAPABILITIES* pCapabilities
)
{
	ZeroMemory(pCapabilities, sizeof(XINPUT_CAPABILITIES));
	pCapabilities->Type = XINPUT_DEVTYPE_GAMEPAD;
	pCapabilities->SubType = XINPUT_DEVSUBTYPE_GAMEPAD;
	pCapabilities->Gamepad.wButtons = 0xFFFF;
	return ERROR_SUCCESS;
}

DWORD WINAPI XInputGetKeystroke(
  DWORD dwUserIndex,
  DWORD dwReserved,
  PXINPUT_KEYSTROKE pKeystroke
)
{
	ZeroMemory(pKeystroke, sizeof(XINPUT_KEYSTROKE));
	return ERROR_SUCCESS;
}

// XInput ͎̓擾API
// {XInputAPIɂ͓nAJoyPadAPIɓn
DWORD WINAPI XInputGetState(
  DWORD dwUserIndex,
  XINPUT_STATE* pState
)
{
	// GameEBhEANeBuH
	if (g_isActive)
	{
		// WCpbh̓͏Ԃ擾
		GetJoyPadState();
	}

	// Gameɂ́u{^͖vԂĂ
	ZeroMemory(pState, sizeof(XINPUT_STATE));
	return ERROR_SUCCESS;
}

DWORD WINAPI XInputSetState(
  DWORD dwUserIndex,
  XINPUT_VIBRATION* pVibration
)
{
	return ERROR_SUCCESS;
}

void WINAPI XInputEnable(
  BOOL enable
)
{
	return;
}


// EBhEvV[W̃tbN֐
// GameEBhEANeBułWCpbhƃL[͑M͔Ă܂߁A
// tOݒ肵ĔANeBûƂ͏~߂
LRESULT CALLBACK WindowProc(
	_In_ HWND   hWnd,
	_In_ UINT   uMsg,
	_In_ WPARAM wParam,
	_In_ LPARAM lParam
)
{
	switch (uMsg)
	{
		// GameEBhEANeBuɂȂ
		case WM_SETFOCUS:
			g_isActive = true;
			break;
		
		// GameEBhEANeBuɂȂ
		case WM_KILLFOCUS:
			g_isActive = false;
			break;

		default:
			break;
	}

	return CallWindowProc(g_WndProc, hWnd, uMsg, wParam, lParam);
}



VOID Init(HANDLE hModule)
{
	// ݒt@CJ
	HANDLE hFile = CreateFile(_T("MVJPad.mvj"), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	
	// JH
	if (hFile != INVALID_HANDLE_VALUE)
	{
		DWORD dwSign[4];
		DWORD Read;

		// VOj`ǂݍ
		ReadFile(hFile, dwSign, 16, &Read, NULL);

		// ݒt@CH
		if (dwSign[0] == 0x504A564D)
		{
			// L[̊蓖ďǂݍ
			ReadFile(hFile, &g_AssignedKey, sizeof(g_AssignedKey), &Read, NULL);
		}

		CloseHandle(hFile);
	}

	ZeroMemory(&g_KeyPressed, sizeof(g_KeyPressed));
	
	
	// GamẽEBhEnh擾
	HWND hWnd = FindWindow(_T("Chrome_WidgetWin_0"), NULL);

	// 擾łH
	if (hWnd != NULL)
	{
		// EBhEvV[WtbNĂ
		g_WndProc = (WNDPROC)GetWindowLong(hWnd, GWL_WNDPROC);
		SetWindowLong(hWnd, GWL_WNDPROC, (LONG)WindowProc);
	}
}

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			Init(hModule);
			break;
		case DLL_PROCESS_DETACH:
			break;
    }

    return TRUE;
}